searchNodes=[{"doc":"A Plug wrapper for use in a Plug.Router or Phoenix.Endpoint to trace the entire request with Spandex.NOTE: If you want to use this in combination with Plug.ErrorHandler or similar &quot;wrapper&quot; plugs, this one should be last so that it traces the effects of the other wrappers.Phoenix integration:defmodule MyAppWeb.Endpoint do use Phoenix.Endpoint, otp_app: :my_app use SpandexPhoenix # ... endPlug integration:defmodule MyApp.Router do use Plug.Router use SpandexPhoenix # ... endOptions for use Macro:filter_traces (arity-1 function reference) A function that takes a Plug.Conn and returns true for requests to be traced. For example, to only trace certain HTTP methods, you could do something like: defmodule MyAppWeb.Endpoint do use Phoenix.Endpoint, otp_app: :my_app use SpandexPhoenix, filter_traces: &amp;__MODULE__.filter_traces/1 def filter_traces(conn) do conn.method in ~w(DELETE GET POST PUT) end endNOTE: Local references to functions in the module being defined (e.g. &amp;function/1) will not work because the module will not be compiled yet when the function is being referenced, so the function does not exist. Referencing the local function using &amp;__MODULE__.function/1 will work, however. Default: (a private function that always returns true):span_name (String) The name to be used for the top level span. Default: “request”:tracer (Atom) The tracing module to be used for the trace. Default: Application.get_env(:spandex_phoenix, :tracer):customize_metadata (arity-1 function reference) A function that takes the Plug.Conn for the current request and returns the desired span options to apply to the top-level span in the trace (as a Keyword). The Plug.Conn is normally evaluated just before the response is sent to the client, to ensure that the most-accurate metadata can be collected. In cases where there is an unhandled error, it may only represent the initial request without any response information. For example, if you want a particular path parameter to show its value in the resource instead of its name, you should do something like: defmodule MyApp.Tracer do use Spandex.Tracer, otp_app: :my_app def customize_metadata(conn) do name = conn.path_params[&quot;name&quot;] || &quot;&quot; conn |&gt; SpandexPhoenix.default_metadata() |&gt; Keyword.update(:resource, &quot;&quot;, &amp;String.replace(&amp;1, &quot;:name&quot;, name)) end end defmodule MyAppWeb.Endpoint do use Phoenix.Endpoint, otp_app: :my_app use SpandexPhoenix, customize_metadata: &amp;MyApp.Tracer.customize_metadata/1 plug Router endNOTE: Local references to functions in the module being defined (e.g. &amp;function/1) will not work because the module will not be compiled yet when the function is being referenced, so the function does not exist. Referencing the local function using &amp;__MODULE__.function/1 will work, however. Default: &amp;SpandexPhoenix.default_metadata/1","ref":"SpandexPhoenix.html","title":"SpandexPhoenix","type":"module"},{"doc":"","ref":"SpandexPhoenix.html#default_metadata/1","title":"SpandexPhoenix.default_metadata/1","type":"function"},{"doc":"Default implementation of the filter_traces function","ref":"SpandexPhoenix.html#trace_all_requests/1","title":"SpandexPhoenix.trace_all_requests/1","type":"function"},{"doc":"Phoenix instrumenter callback module to automatically create spans for Phoenix Controller and View information.Configure your Phoenix Endpoint to use this library as one of its instrumenters:config :my_app, MyAppWeb.Endpoint, # ... existing config ... instrumenters: [SpandexPhoenix.Instrumenter]More details can be found in the Phoenix documentation.","ref":"SpandexPhoenix.Instrumenter.html","title":"SpandexPhoenix.Instrumenter","type":"module"},{"doc":"Defines the :telemetry handlers to attach tracing to Phoenix Telemetry.See install/1 documentation for usage.","ref":"SpandexPhoenix.Telemetry.html","title":"SpandexPhoenix.Telemetry","type":"module"},{"doc":"Installs :telemetry event handlers for Phoenix Telemetry events.Plug.Telemetry must be included in your endpoint or router for traces to function properly. If you upgraded to Phoenix 1.5, you must add the plug yourself. The Phoenix 1.5 installer includes the plug in your endpoint automatically.Options:tracer (Atom) The tracing module to be used for traces in your Endpoint. Default: Application.get_env(:spandex_phoenix, :tracer):endpoint_telemetry_prefix (Atom) The telemetry prefix passed to Plug.Telemetry in the endpoint you want to trace. Default: [:phoenix, :endpoint]:filter_traces (fun((Plug.Conn.t()) -&gt; boolean)) A function that takes a conn and returns true if a trace should be created for that conn, and false if it should be ignored. Default: &amp;SpandexPhoenix.trace_all_requests/1:span_name (String.t()) The name for the span this module creates. Default: &quot;request&quot;:span_opts (Spandex.Tracer.opts()) A list of span options to pass during the creation or continuation of the top level span. Default: [type: :web]:customize_metadata (fun((Plug.Conn.t()) -&gt; Keyword.t())) A function that takes a conn and returns a keyword list of metadata. Default: &amp;SpandexPhoenix.default_metadata/1","ref":"SpandexPhoenix.Telemetry.html#install/1","title":"SpandexPhoenix.Telemetry.install/1","type":"function"},{"doc":"Library forked to provide timely updates.The master branch is used for deployments.The state of the original repository is represented by the upstream branch, so if you would like to make contributions that could be mergable both to our fork and original repository, it's best to start your branch on origin/upstream.SpandexPhoenix Phoenix and Plug integrations for the Spandex tracing library.","ref":"readme.html","title":"SpandexPhoenix","type":"extras"},{"doc":"Add spandex_phoenix to your dendencies in mix.exs:def deps do [ {:spandex_phoenix, &quot;~&gt; 1.1.0&quot;} ] endConfigure it to use your desired Spandex.Tracer module in config.exs:config :spandex_phoenix, tracer: MyApp.TracerUsage: Phx &gt;= 1.5 (Telemetry)Upgrade Note: If you're updating your SpandexPhoenix code from using it with previous versions of Pheonix, you must first remove all the code detailed in Usage: Plug &amp; Phx &lt; 1.5 before following telemetry installation instructions below.SpandexPhoenix supports using Phoenix 1.5's Telemetry events to create spans for Phoenix.Controller timing, with the resource name set to the controller action.To attach Spandex.Telemetry's event handlers, call Spandex.Telemetry.install/{0,1} during your application's startup:defmodule MyApp.Application do def start(_, _) do # ... SpandexPhoenix.Telemetry.install() # ... end endSee Spandex.Telemetry.install/1 documentation for event handler options.Usage: Plug &amp; Phx &lt; 1.5Add use SpandexPhoenix to the appropriate module. This will &quot;wrap&quot; the module with tracing and error-reporting via Spandex.Phoenix integration:defmodule MyAppWeb.Endpoint do use Phoenix.Endpoint, otp_app: :my_app use SpandexPhoenix # ... endIf you use Phoenix, you don't need to use the following integration most likely, otherwise, you get the error messages like[error] Tried to start a trace over top of another tracePlug integration:defmodule MyApp.Router do use Plug.Router use SpandexPhoenix # ... endCustomizing TracesTraces can be customized and filtered by passing options to the use SpandexPhoenix macro. See the documentation for SpandexPhoenix for more information.Integrating with Phoenix InstrumentationIf you are using Phoenix and you configure SpandexPhoenix.Instrumenter in your Phoenix instrumenters list, you will automatically get spans created for Phoenix.Controller and Phoenix.View timing, with the resource set to the name of the controller action or view name.Note that this should be used in addition to the use SpandexPhoenix macro to start the trace and top-level span, as the instrumenter only creates child spans, assuming that the trace will already have been created.Configure your Phoenix Endpoint to use this library as one of its instrumenters:config :my_app, MyAppWeb.Endpoint, # ... existing config ... instrumenters: [SpandexPhoenix.Instrumenter]More details can also be found in the docs on Hexdocs.","ref":"readme.html#usage","title":"SpandexPhoenix - Usage","type":"extras"}]